# evSoc
Python evSoc, derived from EVNotipi and EVNotify

evSoc can be installed directly on the RPi of the openWB wallbox.
evSoc can be installed on separate Server HW (Pi Zero) as a gateway between EV and openWB.

evSoc will provide the StateOfCharge SoC of the Electric Vehicle EV via bluetooth OBD Dongle.
All EVNotipi-Files for supported CARS and DONGLES should remain unchanged (cloned from EVNotipi))

## Needed Hardware within garage (Option)
- Raspberry Pi Zero
- housing for Zero
- power supply for Zero

## Needed Hardware within EV
- ELM327 based OBD-Dongle for bluetooth (tested with TonWon BTS3.0 + EV Kona)

## Installation
### Raspberry Pi
- sudo apt update
- sudo apt upgrade
- sudo apt install python3-{pip,rpi.gpio,serial,requests,sdnotify,pyroute2,smbus,yaml,gevent} gpsd git watchdog rsyslog-

### evSoc
#### UNPACK evSoc.tar files into /opt/evSoc with root-permissions
- cd /opt/evSoc
- sudo pip3 install -r requirements.txt
- sudo systemctl link /opt/evSoc/evSoc.service
- sudo systemctl enable evSoc.service

### Setup the Bluetooth Connection to OBD-Dongle
- sudo bluetoothctl
	power on
	agent on
	default-agent
	scan on
#### find your ID xx:xx:xx:xx:xx:xx
	pair xx:xx:xx:xx:xx:xx
	trust xx:xx:xx:xx:xx:xx
	scan off
	quit
- sudo rfcomm bind rfcomm0 xx:xx:xx:xx:xx:xx
#### ADD Autostart IN /etc/rc.local 
	sudo rfcomm bind rfcomm0 xx:xx:xx:xx:xx:xx

### openWB
#### Configure SoC-receiption via MQTT

### OPTION
#### Setup WiFi connection of PI Zero to the openWB

### Manual Start
- sudo systemctl start evSoc.service


